/* Implements my toy one line factoring algorithm. Not much use for anything, but fun anyway. */
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <math.h>
#include <gmp.h>
#include "flint.h"
#include "long_extras.h"

#define BITS 15
#define REPS 500 //how many iterations to give it before giving up
#define GOS 10000  //number of numbers to try and factor
#define MULTIPLIER 480

int main(int argc, char *argv[])
{    
   ulong factoring;
   ulong going = GOS;
   long numfactored = 0;
   int flag2 = 1;
    
   ulong orig_n, n, in, sqrti, square, mod, factor, p, t;
    
   while (going)
   {
      t = (1L<<BITS);

      factoring = REPS;
      in = 0L;
    
      n = z_randbits(BITS);
      n += t;                     // top bit is always 1
      n = z_nextprime(n);
      
      t = (1L<<BITS);

      p = z_randbits(BITS);
      p += t;                     // top bit is always 1
      p = z_nextprime(p);
      
      n *= p;
          
      /*t <<= 2;

      p = z_randbits(BITS+3);
      p += t;                     // top bit is always 1
      p = z_nextprime(p);
      
      n *= p;*/
      orig_n = n;
          
      n *= MULTIPLIER;

      factoring = REPS;
      double ninv = z_precompute_inverse(orig_n);

      while (factoring)
      {
         in += n;
         sqrti = z_intsqrt(in); 
         sqrti++;
         square = sqrti*sqrti;
		   mod = square - in;
		   if (z_issquare(mod)) 
         {
            mod = z_intsqrt(mod);
            sqrti -= mod;
            factor = z_gcd(orig_n,sqrti);  
            if (factor != 1) 
            { 
               numfactored++;
               break;
            }
         }     
         factoring--;    
      }
      going--;
   }
    
   printf("Done, %ld factored!\n", numfactored);
    
   return 0;
}

              
